#include <cstdio>
#include <cstdint>

#include "cifrasProduto.hpp"

int main(int argc, char *argv[]) {
  uint16_t d,a;
  char *msgClara,*msgCifrada, *chave;
  FILE *pfM, *pfC;
  
  
  if (argc<=3) { // valores de entrada insuficientes 
    printf("\nUtilização: chave_de_encriptação_de_2caracteres_ascii=2bytes nome_ficheiro_msg_clara nome_ficheiro_msg_cifrada\n\n");
    return (1);
  }
  
  chave=argv[1];
  d=chave[0];
  a=chave[1];
  d=d<<8;
  d=d|a;  
  msgClara=argv[2];
  msgCifrada=argv[3];
  
  
  if ((pfM = fopen(msgClara,"r")) == NULL) {
    printf("Não foi possível abrir o ficheiro %s\n",msgClara);
    return (2);
  }
  if ((pfC = fopen(msgCifrada,"w")) == NULL) {
    printf("Não foi possível abrir para escrita o ficheiro %s\n",msgCifrada);
    return (3);
  }

  CifrasProduto cifraProduto;
    
  cifraProduto.desencriptarProduto(pfM,pfC,d);

  fclose(pfM);
  fclose(pfC);

  return(0);
}
